Package icyllis.arc3d.compiler.lex

# Class Token

java.lang.Object
icyllis.arc3d.compiler.lex.Token

public final class Token extends Object
Represents a lexer token that encapsulates the token kind and position. It's packed as a `long` value to reduce object allocation. This class provides static methods to pack and unpack lexer tokens.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final long`
  `NO_TOKEN`
  `static final int`
  `TK_AMP`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_AMPAMP`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_AMPEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_BANG`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_BANGEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_BLOCK_COMMENT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_BREAK`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_BUFFER`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_CARET`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_CARETCARET`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_CARETEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_CASE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_COHERENT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_COLON`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_COMMA`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_CONST`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_CONTINUE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_DEFAULT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_DISCARD`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_DO`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_DOT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_ELSE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_END_OF_FILE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_EQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_EQEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_FALSE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_FLAT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_FLOATLITERAL`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_FOR`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_GT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_GTEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_GTGT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_GTGTEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_HASH`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_IDENTIFIER`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_IF`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_IN`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_INLINE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_INOUT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_INTLITERAL`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_INVALID`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LAYOUT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LBRACE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LBRACKET`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LINE_COMMENT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LPAREN`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LTEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LTLT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_LTLTEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_MINUS`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_MINUSEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_MINUSMINUS`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_NEWLINE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_NOINLINE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_NONE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_NOPERSPECTIVE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_OUT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PERCENT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PERCENTEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PIPE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PIPEEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PIPEPIPE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PLUS`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PLUSEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PLUSPLUS`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_PURE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_QUES`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_RBRACE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_RBRACKET`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_READONLY`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_RESERVED`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_RESTRICT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_RETURN`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_RPAREN`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_SEMICOLON`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_SLASH`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_SLASHEQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_SMOOTH`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_STAR`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_STAREQ`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_STRINGLITERAL`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_STRUCT`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_SUBROUTINE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_SWITCH`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_TILDE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_TRUE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_UNIFORM`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_USING`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_VOLATILE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_WHILE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_WHITESPACE`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_WORKGROUP`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
  `static final int`
  `TK_WRITEONLY`
  Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static int`
  `kind(long token)`
  `static int`
  `length(long token)`
  `static long`
  `make(int kind, int offset, int length)`
  `static int`
  `offset(long token)`
  `static long`
  `replace(long token, int kind)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### TK_END_OF_FILE

    public static final int TK_END_OF_FILE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_INTLITERAL

    public static final int TK_INTLITERAL
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_FLOATLITERAL

    public static final int TK_FLOATLITERAL
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_STRINGLITERAL

    public static final int TK_STRINGLITERAL
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_TRUE

    public static final int TK_TRUE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_FALSE

    public static final int TK_FALSE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_BREAK

    public static final int TK_BREAK
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_CONTINUE

    public static final int TK_CONTINUE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_DO

    public static final int TK_DO
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_FOR

    public static final int TK_FOR
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_WHILE

    public static final int TK_WHILE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_IF

    public static final int TK_IF
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_ELSE

    public static final int TK_ELSE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_SWITCH

    public static final int TK_SWITCH
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_CASE

    public static final int TK_CASE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_DEFAULT

    public static final int TK_DEFAULT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_DISCARD

    public static final int TK_DISCARD
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_RETURN

    public static final int TK_RETURN
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_IN

    public static final int TK_IN
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_OUT

    public static final int TK_OUT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_INOUT

    public static final int TK_INOUT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_CONST

    public static final int TK_CONST
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_UNIFORM

    public static final int TK_UNIFORM
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_BUFFER

    public static final int TK_BUFFER
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_WORKGROUP

    public static final int TK_WORKGROUP
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_SMOOTH

    public static final int TK_SMOOTH
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_FLAT

    public static final int TK_FLAT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_NOPERSPECTIVE

    public static final int TK_NOPERSPECTIVE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_COHERENT

    public static final int TK_COHERENT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_VOLATILE

    public static final int TK_VOLATILE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_RESTRICT

    public static final int TK_RESTRICT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_READONLY

    public static final int TK_READONLY
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_WRITEONLY

    public static final int TK_WRITEONLY
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_SUBROUTINE

    public static final int TK_SUBROUTINE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LAYOUT

    public static final int TK_LAYOUT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_STRUCT

    public static final int TK_STRUCT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_USING

    public static final int TK_USING
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_INLINE

    public static final int TK_INLINE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_NOINLINE

    public static final int TK_NOINLINE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PURE

    public static final int TK_PURE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_RESERVED

    public static final int TK_RESERVED
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_IDENTIFIER

    public static final int TK_IDENTIFIER
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_HASH

    public static final int TK_HASH
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LPAREN

    public static final int TK_LPAREN
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_RPAREN

    public static final int TK_RPAREN
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LBRACE

    public static final int TK_LBRACE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_RBRACE

    public static final int TK_RBRACE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LBRACKET

    public static final int TK_LBRACKET
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_RBRACKET

    public static final int TK_RBRACKET
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_DOT

    public static final int TK_DOT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_COMMA

    public static final int TK_COMMA
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_EQ

    public static final int TK_EQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LT

    public static final int TK_LT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_GT

    public static final int TK_GT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_BANG

    public static final int TK_BANG
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_TILDE

    public static final int TK_TILDE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_QUES

    public static final int TK_QUES
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_COLON

    public static final int TK_COLON
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_EQEQ

    public static final int TK_EQEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LTEQ

    public static final int TK_LTEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_GTEQ

    public static final int TK_GTEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_BANGEQ

    public static final int TK_BANGEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PLUSPLUS

    public static final int TK_PLUSPLUS
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_MINUSMINUS

    public static final int TK_MINUSMINUS
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PLUS

    public static final int TK_PLUS
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_MINUS

    public static final int TK_MINUS
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_STAR

    public static final int TK_STAR
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_SLASH

    public static final int TK_SLASH
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PERCENT

    public static final int TK_PERCENT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LTLT

    public static final int TK_LTLT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_GTGT

    public static final int TK_GTGT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_AMPAMP

    public static final int TK_AMPAMP
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PIPEPIPE

    public static final int TK_PIPEPIPE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_CARETCARET

    public static final int TK_CARETCARET
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_AMP

    public static final int TK_AMP
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PIPE

    public static final int TK_PIPE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_CARET

    public static final int TK_CARET
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PLUSEQ

    public static final int TK_PLUSEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_MINUSEQ

    public static final int TK_MINUSEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_STAREQ

    public static final int TK_STAREQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_SLASHEQ

    public static final int TK_SLASHEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PERCENTEQ

    public static final int TK_PERCENTEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LTLTEQ

    public static final int TK_LTLTEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_GTGTEQ

    public static final int TK_GTGTEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_AMPEQ

    public static final int TK_AMPEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_PIPEEQ

    public static final int TK_PIPEEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_CARETEQ

    public static final int TK_CARETEQ
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_SEMICOLON

    public static final int TK_SEMICOLON
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_NEWLINE

    public static final int TK_NEWLINE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_WHITESPACE

    public static final int TK_WHITESPACE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_LINE_COMMENT

    public static final int TK_LINE_COMMENT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_BLOCK_COMMENT

    public static final int TK_BLOCK_COMMENT
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_INVALID

    public static final int TK_INVALID
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### TK_NONE

    public static final int TK_NONE
    Token Kinds, 0 is reserved for END_OF_FILE, others are sequential and match with lexicon.
    See Also:
      - Constant Field Values

  - ### NO_TOKEN

    public static final long NO_TOKEN
    See Also:
      - Constant Field Values

- ## Method Details

  - ### make

    public static long make(int kind, int offset, int length)

  - ### kind

    public static int kind(long token)

  - ### offset

    public static int offset(long token)

  - ### length

    public static int length(long token)

  - ### replace

    public static long replace(long token, int kind)